package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteFirewallRuleLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewDeleteFirewallRuleLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteFirewallRuleLogic {
	return &DeleteFirewallRuleLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DeleteFirewallRuleLogic) DeleteFirewallRule(req *types.DeleteFirewallRuleReq) (resp *types.DeleteFirewallRuleResp, err error) {
	// todo: add your logic here and delete this line
	DeleteFirewallRuleReq := &openstack.DeleteFirewallPolicyReq{}
	err = copier.CopyWithOption(DeleteFirewallRuleReq, req, copier.Option{Converters: utils.Converters})
	DeleteFirewallRuleResp, err := l.svcCtx.OpenstackRpc.DeleteFirewallPolicy(l.ctx, DeleteFirewallRuleReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&DeleteFirewallRuleResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &DeleteFirewallRuleResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
